#ifndef WIN06_PRN_H
#define WIN06_PRN_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "guidefs.h"

class T_win06 : public QWidget
{
    Q_OBJECT

    QGridLayout *myLayout;
    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QLabel *lab4;
    QLabel *lab5;
    QLabel *lab6;
    QLabel *lab7;
    QLabel *lab8;
    QLabel *lab9;
    QLabel *labSignal;
    QLabel *lab15;

    QLabel *label16;
    QLabel *label17;

    QTimer *myTO;

    QPushButton *butPrnPow;

    QLabel *showPrnState1;
    QLabel *showPrnState2;
    QLabel *showPrnResult;

    QComboBox * cb_templNr;
    QComboBox * cb_kombiNr;

    QByteArray dummyText;


public:
    explicit T_win06(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win06();

private slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);
    void slot_sendDD1(void);
    void slot_sendDD2(void);
    void slot_rdBackDD(void);
    void slot_printVaris(void);
    void slot_printCombi(void);
    void slot_printTicket(void);
    void signalPrnDone(void);
    void signalPrnErr(void);
    void slot_powerButton(void);

    void slot_printLogo(void);
    void slot_printAcc(void);
    void slot_printCut(void);

    void slot_sendText(void);
    void slot_setup(void);
    void slot_movPap(void);
    void slot_movBack(void);
    void slot_fonts(void);
    void slot_letters(void);
    void slot_printQr(void);


};

#endif
